var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_ActionBarContext = __toESM(require("./ActionBarContext"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const ActionBar = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("action-bar", prefixCls);
  const children = (0, import_react.useMemo)(() => import_react.default.Children.toArray(props.children), [props.children]);
  return /* @__PURE__ */ import_react.default.createElement(import_ActionBarContext.default.Provider, {
    value: {
      parent: {
        children
      }
    }
  }, /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(props.className, bem(), {
      "rc-safe-area-bottom": props.safeAreaInsetBottom
    }),
    style: props.style
  }, import_react.default.Children.toArray(props.children).filter(Boolean).map((child, index) => {
    return /* @__PURE__ */ import_react.default.cloneElement(child, {
      index
    });
  })));
};
ActionBar.defaultProps = {
  safeAreaInsetBottom: true
};
var stdin_default = ActionBar;
